<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;





/**
 * @ORM\Entity(repositoryClass="App\Repository\OilStatRepository")
 */
class OilStat
{
    
    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\WheelPairs", inversedBy="oilstat")
     * @ORM\JoinColumn(nullable=true)
     */
    private $wheelpairs;

    public function getWheelPairs(): WheelPairs
    {
        return $this->wheelpairs;
    }

    public function setWheelPairs(WheelPairs $wheelpairs)
    {
        $this->wheelpairs = $wheelpairs;
    }

    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="integer")
     */
    private $isset;

    /**
     * @ORM\Column(type="string")
     */
    private $data;
    

    public function getId()
    {
        return $this->id;
    }

    public function getIsset()
    {
        return $this->isset;
    }

    public function setIsset(int $isset)
    {
        $this->isset = $isset;

        return $this;
    }

    public function getData()
    {
        return $this->data;
    }

    public function setData(string  $data)
    {
        $this->data = $data;

        return $this;
    }
    

}
