<?php

use Doctrine\Common\Collections\ArrayCollection;


/**
 * @ORM\Entity(repositoryClass="App\Repository\WheelPairsRepository")
 */
class WheelPairs
{
    
     // ...

    /**
     * @ManyToOne(targetEntity="OilStat")
     * @JoinColumn(name="wheelpairs_id", referencedColumnName="id")
     */
     
         private $oilstat;
    public function __construct() {
        $this->oilstat = new ArrayCollection();
    }

    /** @Id @Column(type="integer")  */
    private $id;

    /**
     * @ORM\Column(type="integer")
     */
    private $token;
    
    
    /**
     * @ORM\Column(type="integer")
     */
    private $curIsset;
    
    
    /**
     * @ORM\Column(type="string")
     */
    private $data;

    public function getId()
    {
        return $this->id;
    }

    public function getToken()
    {
        return $this->token;
    }

    public function setToken(int $token)
    {
        $this->token = $token;

        return $this;
    }
    
    
    public function getCurIsset()
    {
        return $this->curIsset;
    }

    public function setCurIsset(int $curIsset)
    {
        $this->curIsset = $curIsset;

        return $this;
    }
    
    public function getData()
    {
        return $this->data;
    }

    public function setData(string  $data)
    {
        $this->data = $data;

        return $this;
    }
    
}
