<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "asusg_conditions".
 *
 * @property int $job_id
 * @property int $finished_job_id
 * @property int $started
 */
class AsusgConditions extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_conditions';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['job_id', 'finished_job_id'], 'required'],
            [['job_id', 'finished_job_id', 'started'], 'integer'],
            [['job_id', 'finished_job_id'], 'unique', 'targetAttribute' => ['job_id', 'finished_job_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'job_id' => 'Job ID',
            'finished_job_id' => 'Finished Job ID',
            'started' => 'Started',
        ];
    }
}
