<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "asusg_employee".
 *
 * @property int $id
 * @property string $asu_id
 * @property string $name
 * @property int $smopp_id
 */
class AsusgEmployee extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_employee';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['asu_id', 'name'], 'required'],
            [['smopp_id'], 'integer'],
            [['asu_id'], 'string', 'max' => 45],
            [['name'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'asu_id' => 'Asu ID',
            'name' => 'Name',
            'smopp_id' => 'Smopp ID',
        ];
    }
}
