<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "asusg_job".
 *
 * @property int $id
 * @property int $smopp_task_id
 * @property int $type_id
 * @property int $order
 * @property int $employee_id
 * @property string $created
 * @property string $assigned
 * @property string $accepted
 * @property string $finished
 * @property string $smopp_task_created
 */
class AsusgJob extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_job';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['smopp_task_id', 'type_id', 'order', 'employee_id'], 'integer'],
            [['type_id'], 'required'],
            [['created', 'assigned', 'accepted', 'finished', 'smopp_task_created'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'smopp_task_id' => 'Smopp Task ID',
            'type_id' => 'Type ID',
            'order' => 'Order',
            'employee_id' => 'Employee ID',
            'created' => 'Created',
            'assigned' => 'Assigned',
            'accepted' => 'Accepted',
            'finished' => 'Finished',
            'smopp_task_created' => 'Smopp Task Created',
        ];
    }
}
