<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "checkpoint_type_hierarchy".
 *
 * @property int $parent_cp_type
 * @property int $cp_type
 */
class CheckpointTypeHierarchy extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'checkpoint_type_hierarchy';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['parent_cp_type', 'cp_type'], 'required'],
            [['parent_cp_type', 'cp_type'], 'integer'],
            [['parent_cp_type', 'cp_type'], 'unique', 'targetAttribute' => ['parent_cp_type', 'cp_type']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'parent_cp_type' => 'Parent Cp Type',
            'cp_type' => 'Cp Type',
        ];
    }
}
