<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "checkpoints".
 *
 * @property int $id
 * @property int $priority
 * @property int $type
 * @property int $parent_task_id
 */
class Checkpoints extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'checkpoints';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['priority', 'type', 'parent_task_id'], 'integer'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'priority' => 'Priority',
            'type' => 'Type',
            'parent_task_id' => 'Parent Task ID',
        ];
    }
}
