<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "commands".
 *
 * @property int $id
 * @property int $account_id
 * @property string $cmd
 * @property string $created
 */
class Commands extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'commands';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['account_id'], 'integer'],
            [['created'], 'safe'],
            [['cmd'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'account_id' => 'Account ID',
            'cmd' => 'Cmd',
            'created' => 'Created',
        ];
    }
}
