<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "positons".
 *
 * @property int $id
 * @property string $name
 * @property string $uuid
 */
class Positions extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'positions';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'uuid'], 'required'],
            [['name', 'uuid'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'uuid' => 'Uuid',
        ];
    }
}
