<?php /** Created by Anton on 29.01.2020. */

namespace app\models\entity;

/**
 * This is the model class for table "tmc_type".
 *
 * @property int $id
 * @property string $title
 */
class TmcType extends \yii\db\ActiveRecord
{
    const TMC_TYPE_CAMERA = 1;
    const TMC_TYPE_OIL_METER = 2;
    const TMC_TYPE_PHONE = 3;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tmc_type';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['title'], 'string', 'max' => 255],
        ];
    }
}