<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "so_wp_logs".
 *
 * @property int $id
 * @property int $id_session
 * @property string $old_val
 * @property int $new_val
 */
class WpLogs extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'so_wp_logs';
    }
    
    
    public static function getDb()
    {
        return \Yii::$app->slave_db;
    }
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id_session', 'old_val', 'new_val'], 'required'],
            [['id_session'], 'integer'],
            [['old_val'], 'string'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'id_session' => 'Id Session',
            'old_val' => 'Old Val',
            'new_val' => 'New Val',
        ];
    }
}
