<?php

namespace app\models;

use Yii;
use yii\base\Model;
use app\models\entity\CheckpointTypes;
use app\models\entity\CheckpointTypeHierarchy;
use app\models\entity\CheckpointTypesForTasks;

/*

add_cpt: BEGIN
	declare classname varchar(255);
    declare tmp integer;
    declare maxpriority integer;


    
    if checkpoint is null then leave add_cpt; end if;
    
 
    
    case checkpointtype
		when 1 then
			set classname = 'DropList';
		when 2 then
			set classname = 'MultiSelect';
		else
			set classname = 'SerialNumber';
	end case;
    
// 1  получение ид чекпоинта
    
    select id into checkpoint_id
		from checkpoint_types
        where name = checkpoint
			and class = classname;


    if checkpoint_id is null then
		insert into checkpoint_types
			(name, class)
            values
            (checkpoint, classname);
		select id into checkpoint_id
			from checkpoint_types
			where name = checkpoint
				and class = classname;
    end if;

// 2
    
	select cp_type_id into tmp
		from checkpoint_types_for_tasks
        where tasktype_id = cmd_id
			and cp_type_id = checkpoint_id;
	if tmp is null then
		select max(coalesce(priority, 0)) + 1 into maxpriority
			from checkpoint_types_for_tasks
            where tasktype_id = cmd_id;
		insert into checkpoint_types_for_tasks
			(tasktype_id, cp_type_id, priority)
			values
			(cmd_id, checkpoint_id, maxpriority);
	end if;
END
*/

class AsusgAddCheckpointTypeModel extends Model
{
    private $tmp;
    private $classname;
    private $maxpriority;

    
    public function execute( $cmd_id, $checkpoint, $checkpointtype, $checkpoint_id ) 
    {
        $this->cmd_id         = $cmd_id;
        $this->checkpoint     = $checkpoint;
        $this->checkpointtype = $checkpointtype;
        $this->checkpoint_id  = $checkpoint_id;
        
        if ( null == $this->checkpoint ){
            return false;
        }
        
        switch ($checkpointtype) {
            case 1 :
                $this->classname = 'DropList';
                break;
            case 2:
                $this->classname = 'MultiSelect';
                break;
            default:
                $this->classname = 'SerialNumber';
                break;
        }
        
        // 1 получение ид чекпоинта
        if(!$this->GetCheckpoint()) {
            return false;
        }

        // 2 
        if(!$this->MaxPriority()) {
            return false;
        }
        return true;
    }
    
    private function GetCheckpoint(){
    
        $checkpointTypesEntity = CheckpointTypes::findOne(['name' => $this->checkpoint, 'class' => $this->classname]);
        $this->checkpoint_id = $checkpointTypesEntity->id;
        if ( null == $this->checkpoint_id) {
            if(!$this->CheckIssetCheckpoint()) {
                return false;
            }
        } 
        return true;
    }
    
    private function CheckIssetCheckpoint(){
    
        $CheckpointTypesEntity = new CheckpointTypes();
        $CheckpointTypesEntity->name  = $this->checkbox;
        $CheckpointTypesEntity->class = 'CheckBox';
        $CheckpointTypesEntity->save();
        $this->checkpoint_id = $CheckpointTypesEntity->id;
        if ( null == $this->checkpoint_id) {
            return false;
        } 
        return true;   
    }
    
    private function MaxPriority() {
    
        $CheckpointTypesForTasks = CheckpointTypesForTasks::find()->where(['tasktype_id' => $this->cmd_id, 'cp_type_id' => $this->checkpoint_id])->one();
        $this->tmp = $CheckpointTypesForTasks->cp_type_id;
        if ( null == $this->tmp) {
            $query = 'select (max(coalesce(priority, 0)) + 1) as pr from checkpoint_types_for_tasks where tasktype_id = cmd_id';
            $res = Yii::$app->db->createCommand($query)->queryOne();
            $this->maxpriority = $res["pr"];
            $checkpointTypesForTasks = new CheckpointTypesForTasks();
            $checkpointTypesForTasks->tasktype_id = 
            $checkpointTypesForTasks->cp_type_id  =
            $checkpointTypesForTasks->priority    =
        }
        select cp_type_id into tmp
            from checkpoint_types_for_tasks
            where tasktype_id = cmd_id
                and cp_type_id = checkpoint_id;
        if tmp is null then
            select max(coalesce(priority, 0)) + 1 into maxpriority
                from checkpoint_types_for_tasks
                where tasktype_id = cmd_id;
            insert into checkpoint_types_for_tasks
                (tasktype_id, cp_type_id, priority)
                values
                (cmd_id, checkpoint_id, maxpriority);
        end if;
    }
}
