<?php


defined('YII_DEBUG') or define('YII_DEBUG', true);
defined('YII_ENV') or define('YII_ENV', 'dev');

require __DIR__ . '/api/vendor/autoload.php';
require __DIR__ . '/api/vendor/yiisoft/yii2/Yii.php';

$config = require __DIR__ . '/api/config/web.php';

(new yii\web\Application($config));

require_once "doctrine/bootstrap.php";
include 'CheckPoint.php';
include 'CheckPointType.php';
use CheckPoints\CheckPoint;
use CheckPointTypes\CheckPointType;
header("Expires: 0");
header("Content-Type: text/html; charset=utf-8");
session_start();
$url = explode('?',$_SERVER["REQUEST_URI"])[0];


if (isset($_SESSION['LAST_ACTIVITY']) && (time() - $_SESSION['LAST_ACTIVITY'] > 6000)) {
    // last request was more than 30 minutes ago
    session_unset();     // unset $_SESSION variable for the run-time
    session_destroy();   // destroy session data in storage
}
$_SESSION['LAST_ACTIVITY'] = time(); // update last activity time stamp

$add = 'Login Area';

foreach (array_keys($_REQUEST) as $var) {
    ${$var} = $_REQUEST[$var];
    //if ($name == "Admin12") {
//    echo "<b>$var:</b> ${$var} <br>";
//}
}

if ($act == "exit")
{
session_unset();
session_destroy();
session_start();
}


if ($_SESSION['cmdlevel'])
    $cmdlevel = $_SESSION['cmdlevel'];
if ($_SESSION['hostid'])
    $agent_id = $_SESSION['hostid'];
if ($_SESSION['add'])
    $add = $_SESSION['add'];
if ($_SESSION['id'])
    $id = $_SESSION['id'];
if ($_SESSION['login'])
    $login = $_SESSION['login'];
if ($_SESSION['name'])
    $name = $_SESSION['name'];

foreach (array_keys($_SESSION) as $var) {
${$var} = $_SESSION[$var];
//if ($name == "Admin12") {
//echo "from session: <b>$var:</b> ${$var} <br>";
//}
}

include 'functions.php';
include 'auth.php';

$logged_me_in_successfully234 = 0;
$incl = '';
if (!$_SESSION['pass'] && !$_SESSION['login'])
{
    $table = 'accounts';

    $result=mysqli_query($link, "SELECT id, login, name, cmdlevel FROM $table WHERE login='".$login."' AND password='".md5($pass)."'");
    $res1 = mysqli_fetch_array($result);
    $cmdlevel = $res1['cmdlevel'];
    $name = $res1['name'];
    $id = $res1['id'];

    if ($cmdlevel == '10')
    {
        $add = "Head Administrator";
    }
    else if ($cmdlevel == '1')
    {
        $add = "Company Administrator";
    }
    else if ($cmdlevel == '2')
    {
        $add = "Company Operator";
    }

    if (mysqli_num_rows($result))
    {
        $_SESSION['pass']=$pass;
        $_SESSION['login']=$login;
        $_SESSION['name']=$name;
        $_SESSION['add']=$add;
        $_SESSION['cmdlevel']=$cmdlevel;
        $_SESSION['id']=$id;
        $logged_me_in_successfully234 = 1;
    }
}
else
    $logged_me_in_successfully234 = 1;
    $query = mysqli_query($link, "update accounts set last_seen_web =NOW() where id=".$id);
$getincl = GetInclude($act, intval($cmdlevel));

$incl = $getincl[0];
$accnum = $getincl[1];

$asusgproject = Yii::$app->request->get('asusgproject');
$locomotiveEntity = null;
$projectEntity = null;
if ( $asusgproject ) {
    $projectEntity = \app\models\entity\AsusgProjectType::findOne(['id'=>$asusgproject]);
    $locomotiveEntity = \app\models\entity\LocomotiveSeries::findOne($projectEntity->loco_serie_id);
    
}
?>
<!DOCTYPE html>
<html lang="en">
<head>

  <!-- Basic Page Needs
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->
  <meta charset="utf-8">
  <title>ASUSG</title>
  <meta name="description" content="">
  <meta name="author" content="">

  <!-- Mobile Specific Metas
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- FONT
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->
  
    

 <link rel="stylesheet" href="/lte/bower_components/bootstrap/dist/css/bootstrap.min.css">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="/lte/bower_components/font-awesome/css/font-awesome.min.css">
  <!-- Ionicons -->
  <link rel="stylesheet" href="/lte/bower_components/Ionicons/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="/lte/dist/css/AdminLTE.min.css">
  <!-- AdminLTE Skins. Choose a skin from the css/skins
       folder instead of downloading all of them to reduce the load. -->
  <link rel="stylesheet" href="/lte/dist/css/skins/_all-skins.min.css">
  <!-- Morris chart -->
  <link rel="stylesheet" href="/lte/bower_components/morris.js/morris.css">
  <!-- jvectormap -->
  <link rel="stylesheet" href="/lte/bower_components/jvectormap/jquery-jvectormap.css">
  <!-- Date Picker -->
  <link rel="stylesheet" href="/lte/bower_components/bootstrap-datepicker/dist/css/bootstrap-datepicker.min.css">
  <!-- Daterange picker -->
  <link rel="stylesheet" href="/lte/bower_components/bootstrap-daterangepicker/daterangepicker.css">
  <!-- bootstrap wysihtml5 - text editor -->
  <link rel="stylesheet" href="/lte/plugins/bootstrap-wysihtml5/bootstrap3-wysihtml5.min.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,600,700,300italic,400italic,600italic">
    <link rel="stylesheet" href="/lte/bower_components/select2/dist/css/select2.min.css">
    <link rel="stylesheet" href="/lte/bower_components/datatables.net-bs/css/dataTables.bootstrap.min.css">
    

</head>
<body onload="accon(<? echo $accnum;?>)" >

<!--<div style="min-width: 960px; height: 100%;">-->
<?

$mycompany = getCompanyByAccount($id);

if (!isset($companyID))
{
//	echo "ses com ".$_SESSION['company'];
    if ($_SESSION['company'])
        $companyID = $_SESSION['company'];
    else
    {
        $companyID = $mycompany[0];
        $_SESSION['company'] = $companyID;
    }
}
else
{
    $_SESSION['company'] = $companyID;
}
$companyname = getCompanyByID($companyID)[1];
if ((int)$_POST['appMykey'] == 123465) {$logged_me_in_successfully234 = 1;}
if ($logged_me_in_successfully234 == 0)
{
    echo "<center>";
    GetEnterForm();
    echo("<font color='red'><b>Access denied. Incorrect login or password</b><font>");
    echo "</center>";
    return;
}
//$asusgTaskTemplatesEntity = \app\models\entity\AsusgTasktemplate::find()->orderBy(['id' => SORT_ASC])->all();
//$asusgEmployeeEntity = \app\models\entity\AsusgEmployee::find()->orderBy(['name' => SORT_ASC])->all();
$asusgJobplanEntity = \app\models\entity\AsusgJobplan::find()->orderBy(['name' => SORT_ASC])->all();
$asusgJob2CommandEntity = \app\models\entity\AsusgJob2Command::find()->where(['asusg_projecttype_id'=> Yii::$app->request->get('asusgproject')])->orderBy(['job_order' => SORT_ASC])->all();
//$tasktypesEntity = \app\models\entity\Tasktypes::find()->where(['main_task' => 0,'company' => $companyID])->orderBy(['name' => SORT_ASC])->all();

$locomotiveSeriesEntity = \app\models\entity\LocomotiveSeries::find()->orderBy(['name' => SORT_ASC])->all();

$projectTypesEntity = \app\models\entity\AsusgProjectType::find()->all();
$typeFix = ['1' => 'ТО-1','2' => 'ТО-2','3' => 'ТО-3','4' => 'ТО-4','5' => 'ТО-5',];


//$projectsLocotechEntity = getLocomotiveList();
$projectsLocotechEntity = \app\models\entity\ProjectsLocotech::find()->where(["!=", "uuid" , ''])->all();
//$series = LocoSeries::GetAllNames();
?>


<!-- HTML -->


    <div class="wrapper">

  <header class="main-header">
    <!-- Logo -->
    <a href="/asusg_plan.php" class="logo">
      <!-- mini logo for sidebar mini 50x50 pixels -->
      <span class="logo-mini"><b>A</b>LT</span>
      <!-- logo for regular state and mobile devices -->
      <span class="logo-lg"><b>АСУ</b>СГ</span>
    </a>
    <!-- Header Navbar: style can be found in header.less -->
    <nav class="navbar navbar-static-top">
      <!-- Sidebar toggle button-->
      <a href="#" class="sidebar-toggle" data-toggle="push-menu" role="button">
        <span class="sr-only">Toggle navigation</span>
      </a>

      
    </nav>
  </header>
  <!-- Left side column. contains the logo and sidebar -->
  <aside class="main-sidebar">
    <!-- sidebar: style can be found in sidebar.less -->
    <section class="sidebar">
      <!-- Sidebar user panel -->
      
      <!-- search form -->
      <form action="#" method="get" class="sidebar-form">
        <div class="input-group">
          <input type="text" name="q" class="form-control" placeholder="Search...">
          <span class="input-group-btn">
                <button type="submit" name="search" id="search-btn" class="btn btn-flat"><i class="fa fa-search"></i>
                </button>
              </span>
        </div>
      </form>
      <!-- /.search form -->
      <!-- sidebar menu: : style can be found in sidebar.less -->
      <?php require_once 'asusg_menu.php';?>
    </section>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <h1>
        Список проектов
        
      </h1>
      <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="active">Dashboard</li>
      </ol>
    </section>
    <!-- Main content -->
    <section class="content">      
        <div class="row">
            <div class="col-md-12">
                <div class="nav-tabs-custom">
                    <div class="row">
                        <div class="col-xs-5">
                            <div class="box">
                                <div class="box-header">
                                    <h3 class="box-title">Список проектов</h3>
                                </div>
                                <div class="box-body">
                                <form id="addNewProjectTypesAsusgForm">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                        <tr>
                                        <th>Серия</th>
                                        <th>Вид ремонта</th>
                                        <th>Действие</th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        <tr>    
                                            <td>
                                                <div class="form-group">
                                                    <select id="loco_series_command" name="loco_series" class="form-control select2" style="width: 100%;">
                                                        <? foreach( $locomotiveSeriesEntity as $loco):?>
                                                            <option value="<?php echo $loco->id?>"><?php echo $loco->name;?></option>
                                                        <? endforeach;?>
                                                    </select>
                                                </div> 
                                            </td>
                                            <td>
                                                <div class="form-group">
                                                    <select id="type_fix_id" name="typefix" class="form-control select2" style="width: 100%;">
                                                        <? foreach( $typeFix as $key => $type):?>
                                                            <option data_id="1" value="<?php echo $key;?>"><?php echo $type;?></option>
                                                        <? endforeach;?>
                                                    </select>
                                                </div>
                                            </td>
                                            <td><button id="addNewProjectTypesAsusg" type="button" class="btn btn-block btn-primary " data_id="<?php echo $template->asusg_id;?>">Добавить</button></td>
                                        </tr>
                                        <? foreach( $projectTypesEntity as $key => $type):?>
                                            <tr onclick="location.href='<?php echo $url;?>?asusgproject=<?php echo $type->id;?>'">
                                                <td><?php echo $type->locomotiveseries->name;?></td>
                                                <td><?php echo $typeFix[$type->repair_type]?></td>
                                                <td><button id="removeProjectTypesAsusg" type="button" class="btn btn-block btn-danger" data_id="<?php echo $type->loco_serie_id;?>@<?php echo $type->repair_type;?>">Удалить</button></td>
                                            </tr>
                                        <? endforeach;?>
                                        </tbody>
                                    </table>
                                </form>
                                </div>
                                <!-- /.box-body -->
                            </div>   
                        </div>
                        <div class="col-xs-7">
                            <div class="box">
                                    <div class="box-body">
                                        <div class="row">
                                            <div class="col-xs-5"> 
                                                <div class="form-group">
                                                    <label for="exampleInputEmail1">Серия локомотива</label>
                                                    <br>
                                                    <? if ( null != $locomotiveEntity):?>
                                                        <?php echo $locomotiveEntity->name;?>
                                                    <? endif;?>
                                                </div>
                                            </div>
                                            <div class="col-xs-3 col-xs-offset-1"> 
                                                <div class="form-group">
                                                    <label for="exampleInputPassword1">Вид ремонта</label>
                                                    <br>
                                                    
                                                    <? if ( null != $projectEntity):?>
                                                        <?php echo $typeFix[$projectEntity->repair_type];?>
                                                    <? endif;?>
                                                </div>
                                            </div>
                                            <div class="col-xs-3 "> 
                                                <label for="exampleInputPassword1">Сохранить проект</label>
                                                <button type="button" class="btn btn-block btn-primary saveProjectTypesForAsusg" job_id="<?php echo Yii::$app->request->get('asusgproject')?>">Сохранить</button>
                                            </div>
                                            <div class="col-xs-5"> 
                                                <label for="exampleInputPassword1">Список работ</label>
                                                <select class="form-control select2" style="width: 100%;" id="listJobForAsusg">
                                                    <? foreach( $asusgJobplanEntity as $template):?>
                                                        <option value="<?php echo $template->id?>" data_id_option="<?php echo $template->id?>"><?php echo $template->name?></option>
                                                    <? endforeach;?>
                                                </select>    
                                            <div>
                                        </div>
                                    </div>
                                    <div class="col-xs-3"> 
                                        <label for="exampleInputPassword1">Добавить работу</label>
                                        <button id="bindNewProjectTypesAsusg" type="button" class="btn btn-block btn-primary">Добавить</button>
                                    </div>
                                </div>
                                    <!-- /.box-body --> 
                                </div>
                                <div class="box-body">
                                    <div class="col-xs-8"> 
                                        <ul id="sortable" class="list-unstyled list_asusg_command_id sortable">
                                            <? $i = 100;?>
                                            <? foreach ($asusgJob2CommandEntity as $item):?>                                        
                                                <? //if ($item->asusg_projecttype_id == $template->asusg_id):?>
                                                <li id="li_<?php echo $item->asusg_projecttype_id;?>" class="ui-state-default" data_id="<?php echo $item->asusg_jobplan_id;?>_<?php echo $i;?>"><span class="ui-icon ui-icon-arrowthick-2-n-s"></span>
                                                    <div class="box box-warning">
                                                        <div class="box-header with-border">
                                                        <h3 class="box-title"><?php echo  $item->jobplan->name;?></h3>
                                                        <div class="box-tools pull-right">
                                                            <button type="button" class="btn btn-box-tool remove_command_button_asusg" data-widget="remove" data_id="<?php echo $item->asusg_jobplan_id;?>_<?php echo $i;?>"><i class="fa fa-times"></i></button>
                                                        </div>
                                                        </div>
                                                    </div>
                                                </li>
                                                <? //endif;?>
                                                <?php $i++;?>
                                            <? endforeach;?>
                                        </ul>  
                                    </div> 
                                </div>
                            </div>
                        </div> 
                    </div>    
                </div>
            </div>
        </div>    
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    
  </footer>

  <!-- Add the sidebar's background. This div must be placed
       immediately after the control sidebar -->
  <div class="control-sidebar-bg"></div>
</div>
<!-- HTML -->
<!-- End Document
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->

    
    <script src="/lte/bower_components/jquery/dist/jquery.min.js"></script>
<!-- jQuery UI 1.11.4 -->
<script src="/lte/bower_components/jquery-ui/jquery-ui.min.js"></script>
<!-- Resolve conflict in jQuery UI tooltip with Bootstrap tooltip -->
<script>
  $.widget.bridge('uibutton', $.ui.button);
</script>
<!-- Bootstrap 3.3.7 -->
<script src="/lte/bower_components/bootstrap/dist/js/bootstrap.min.js"></script>
<!-- Morris.js charts -->
<script src="/lte/bower_components/raphael/raphael.min.js"></script>
<script src="/lte/bower_components/morris.js/morris.min.js"></script>
<!-- Sparkline -->
<script src="/lte/bower_components/jquery-sparkline/dist/jquery.sparkline.min.js"></script>
<!-- jvectormap -->
<script src="/lte/plugins/jvectormap/jquery-jvectormap-1.2.2.min.js"></script>
<script src="/lte/plugins/jvectormap/jquery-jvectormap-world-mill-en.js"></script>
<!-- jQuery Knob Chart -->
<script src="/lte/bower_components/jquery-knob/dist/jquery.knob.min.js"></script>
<!-- daterangepicker -->
<script src="/lte/bower_components/moment/min/moment.min.js"></script>
<script src="/lte/bower_components/bootstrap-daterangepicker/daterangepicker.js"></script>
<!-- datepicker -->
<script src="/lte/bower_components/bootstrap-datepicker/dist/js/bootstrap-datepicker.min.js"></script>
<!-- Bootstrap WYSIHTML5 -->
<script src="/lte/plugins/bootstrap-wysihtml5/bootstrap3-wysihtml5.all.min.js"></script>
<!-- Slimscroll -->
<script src="/lte/bower_components/jquery-slimscroll/jquery.slimscroll.min.js"></script>
<!-- FastClick -->
<script src="/lte/bower_components/fastclick/lib/fastclick.js"></script>
<!-- AdminLTE App -->
<script src="/lte/dist/js/adminlte.min.js"></script>
<!-- AdminLTE dashboard demo (This is only for demo purposes) -->
<script src="/lte/dist/js/pages/dashboard.js"></script>
<script src="/lte/bower_components/datatables.net/js/jquery.dataTables.min.js"></script>
<script src="/lte/bower_components/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="/lte/dist/js/demo.js"></script>
<script src="/loco.js"></script>
<script src="/mail.js"></script>
<script src="/lte/bower_components/select2/dist/js/select2.full.min.js"></script>  
<script>
  $( function() {
    $( ".sortable" ).sortable();
    $( ".sortable" ).disableSelection();
  } );
</script>
</body>
</html>


<?php
function GetEnterForm()
{
    echo "<article>
<form method='post' action='?login'>
<table>
	<tr>
		<td width=70>
			<b>Login</b>
		</td>
		<td>
			&nbsp;
		</td>
		<td>
			<input type='text' name=login value=''><br/>
		</td>
	</tr>
	<tr>
		<td>
		<b>Password </b>
		</td>
		<td>
			&nbsp;
		</td>
		<td>
			<input type='password' name=pass value=''>
		</td>				
	</tr>
	<tr>
		<td></td>
		<td>&nbsp;</td>	
		<td>
			<input type='submit' value='Enter'>
		</td>				
	</tr>	
</table>
</form>
</article>";
}

function getLocomotiveList(){
    
        $result = [];
        //var_dump($companyID);
        $projectsLocotechEntity = \app\models\entity\ProjectsLocotech::find()->where(['company' => 2] )->orderBy(['id' => SORT_DESC])->all();
        $listArray = [];
        foreach( $projectsLocotechEntity as $item){    //var_dump($item->projecttypes->name);echo "\n";
            //$tempArray = GetTasksForProject($item->id);
            $status = GetProjectStatus($item->id);
            if ($status != 2 && $status != 1) {continue;}
            $countDone = ['done' => 0, 'all' => 0 ]; 
            foreach( GetTasksForProject($item->id) as $proj) { //var_dump($proj);echo "<br>";
                $countDone['all']++;
                $tempArray = $proj;
                $tempArray['status'] = CheckAcceptedStatus($proj);
                $tempArray['name'] = GetTaskNameAndDesc($proj['type'])[0];
                //$tempArray['listAccounts'] = $this->getAccountListForTask($proj['type']);
                if ( 5 == $tempArray['status'] ) {$countDone['done']++;}
                //$countDone['all'] ." / " . $countDone['done'];
                $listArray[] = $tempArray;
                
            }
            $result[$item->id]['countDone'] = [ 'done' => $countDone['done'], 'all' => $countDone['all'] ];
            //$tempArray['name'] = GetTaskNameAndDesc($tempArray['type'])[0];
                
            $result[$item->id]['arr'] = $listArray;//GetTasksForProject($item->id);
            $result[$item->id]['obj'] = $item;
            $listArray = [];
        }
        //exit;
        return $result;
        
    }
function CheckAcceptedStatus($task) {
    
        $result = false;
        $query = "select if(tx.total = tx.finished, 5, if (tx.accepted <> tx.finished, if(tx.attention > 0, 7, 2), if (tx.accepted = 0, 1, 3))) as taskstatus
            from (select count(t.id) as total,
                sum(if(t.accepted_time is not null, 1, 0)) as accepted,
                sum(if(t.finished_time is not null, 1, 0)) as finished,
                        sum(if(t.finished_time is null, if(timestampdiff(MINUTE, t.accepted_time, NOW()) > tt.time_to_complete_minutes, 1, 0), 0)) as attention
                from tasks t
                right join tasktypes tt on t.type = tt.id
                    where t.parent_id = ".$task['id'].") tx;";
         $result = \Yii::$app->db->createCommand($query)->queryAll();            
         $result = $result[0]["taskstatus"];
        
        return $result;
    }    

?>
