<?php /** Created by Anton on 05.02.2020. */

$query = new \yii\db\Query();
$query->select('id, name, company')
    ->from(\app\models\entity\Accounts::tableName())
    ->where(['company' => $companyID])
;
$employees = $query->all();//Список сотрудников текущего подразделения

usort($employees, function($a, $b) {
    if ($a['name'] == $b['name']) {
        return 0;
    }
    return ($a['name'] < $b['name']) ? -1 : 1;
});
?>
<div class="divContentScroll loco-scrol-blue">
    <div id="contentBox" class="contentBox">
        <p class="crumbs">Список устройств у сотрудников » Выдать устройство</p>
        <h2 class="contentHeader">Введите данные для выдачи устройства</h2>
        <form action="/tmc/api/give_tmc.php" method="post">
            <input type="hidden" name="_csrf" value="">
            <fieldset>
                Сотрудник:
                <select class="" name="user">
                    <option value="0">Выберите сотрудника...</option>
                    <?php foreach ($employees as $employee): ?>
                        <option value="<?= $employee['id'] ?>"><?= $employee['name'] ?></option>
                    <?php endforeach; ?>
                </select>
                <br clear="all">
                <br>
                Инвентарный номер:
                <br>
                <input name="inventoryNum" type="text" placeholder="Введете инвентарный номер">
                <br>
                <input type="hidden" name="company" value="<?= $companyID ?>">
            </fieldset>
            <button type="submit" class="">Выдать устройство</button>
        </form>
        <div class="js-user-devices">
            <!--Заполняется ajax запросом-->
        </div>
    </div>
</div>
<script type="application/javascript">
    <?php require dirname(__DIR__) . '/js/give.js'; ?>
</script>