<?php /** Created by Anton on 14.02.2020. */ ?>

<div class="divContentScroll loco-scrol-blue">
    <div id="contentBox" class="contentBox" style="padding-top: 15px;">
        <div style="height: calc(100vh - 178px);" class="loko-div">
            <ul class="nav nav-tabs">
                <?php $storages = [1 => 'склад', 2 => 'стеллаж'] ?>
                <?php foreach ($storages as $key => $storage): ?>
                    <li<?= $key == 1 ? ' class="active"' : '' ?>>
                        <a data-toggle="tab" href="new_storage<?= $key ?>">Добавить <?= $storage ?></a>
                    </li>
                <?php endforeach; ?>
            </ul>
            <div class="tab-content">
                <div id="new_storage1" class="form tab-pane">
                    <br/>
                    <p class="crumbs">Места хранения » Добавить склад</p>
                    <h2 class="contentHeader">Введите данные для создания склада</h2>
                    <form action="/tmc/api/add_warehouse.php" method="post">
                        <div>
                            <input type="hidden" name="_csrf" value="">
                        </div>
                        <fieldset>
                            <div>Наименование:</div>
                            <div>
                                <input name="title" type="text" placeholder="Введете наименование склада" />
                            </div>
                            <br />
                            <div>Номер:</div>
                            <div>
                                <input name="number" type="text" placeholder="Введете номер склада" />
                            </div>
                            <input name="company" type="hidden" value="<?= $companyID ?>"/>
                        </fieldset>
                        <br />
                        <div>
                            <button type="submit" class="">Добавить склад</button>
                        </div>
                    </form>
                </div>
                <div id="new_storage2" class="form tab-pane">
                    <br />
                    <p class="crumbs">Места хранения » Добавить стеллаж</p>
                    <h2 class="contentHeader">Введите данные для создания стеллажа</h2>
                    <form action="/tmc/api/add_stack.php" method="post">
                        <div>
                            <input type="hidden" name="_csrf" value="">
                        </div>
                        <fieldset>
                            <div>Склад:</div>
                            <div>
                                <select name="warehouse">
                                    <?php foreach ($warehouses as $warehouse): ?>
                                        <option value="<?= $warehouse['id'] ?>"><?= $warehouse->number . ' склад' ?></option>
                                    <?php endforeach; ?>
                                </select><br clear="all">
                            </div>
                            <br />
                            <div>Номер:</div>
                            <div>
                                <input name="number" type="text" placeholder="Введете номер стеллажа" />
                            </div>
                            <br />
                            <div>Количеств ячеек:</div>
                            <div>
                                <input name="count" type="text" placeholder="Введете количество ячеек в стеллаже" />
                            </div>
                        </fieldset>
                        <br />
                        <div>
                            <button type="submit" class="">Добавить стеллаж</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>