<?php
/**
 * @var int $cmdlevel
 * @var string $act
 */

use classes\HTML;

if (!$act) $act = '';
?>
<!-- Вертикальное меню слева -->
    <div class="popUpMenu" id="popUpMain">
        <a href="/">Главная</a>
<!--        <a href="#">О проекте</a>-->
<!--        <a href="#">Контакты техподдержки</a>-->
    </div>

    <div class="popUpMenu" id="popUpProject">
        <?php if ($cmdlevel == 10) {
            HTML::a('project_types', 'Типы проектов', $act);
            HTML::a('projects', 'Проекты', $act, true);
            HTML::a('filelib', 'Файлотека', $act);
            HTML::a('oprt_management', 'СОУ', $act);
            HTML::a('loco', 'Локомотивы', $act);
            HTML::a('analytics', 'Аналитика', $act);
            HTML::a('mp_using', 'Использование МП', $act);
            HTML::a('locations', 'Локации', $act);
            HTML::a('algo', 'Алгоритмы', $act);
        } ?>
    </div>
    <div class="popUpMenu" id="popUpTask">
        <?php if ($cmdlevel == 2 || $cmdlevel == 10) {
            HTML::a('tasktypes', 'Типы задач', $act);
            HTML::a('tasks', 'Активные задачи', $act);
            HTML::a('checkpoints', 'Контрольные карты', $act);
            HTML::a('checkitems', 'Справочник вариантов', $act);
            HTML::a('asusg_dayplan', 'План на дату', $act);
        } ?>
    </div>
    <div class="popUpMenu" id="popUpLocation">
        <?php if ($cmdlevel == 10 || $cmdlevel == 1) {
            HTML::a('jobs', 'Должности', $act);
            HTML::a('', '', $act);
        } ?>
        <?php if ($cmdlevel == 1 || $cmdlevel == 2 || $cmdlevel == 10) {
            HTML::a('staff', 'Сотрудники', $act);
            HTML::a('penalties', 'Штрафы', $act);
        } ?>
    </div>
    <div class="popUpMenu" id="popUpWorker">
        <?php if ($cmdlevel == 10 || $cmdlevel == 1) {
            HTML::a('object', 'Редактор объектов', $act);
            HTML::a('typeobject', 'Типы объектов', $act);
        } ?>
        <?php if ($cmdlevel == 10) {
            HTML::a('devices', 'Клиентские устройства', $act);
        } ?>
        <?php if ($cmdlevel == 10 || $cmdlevel == 2) {
            HTML::a('markers', 'Визуальные метки (QR)', $act);
        } ?>
    </div>
    <div class="popUpMenu" id="popUpHandbook">
        <?php
            HTML::a('tmc/list_materials', 'Список устройств', $act);
            HTML::a('tmc/repair_list', 'Список устройств в ремонте', $act);
            HTML::a('tmc/write_list', 'Список списанных устройств', $act);
            HTML::a('tmc/repair', 'Отправить устройство в ремонт', $act);
            HTML::a('tmc/edit', 'Перевести на другой склад', $act);
            HTML::a('tmc/write', 'Списать устройство', $act);
            HTML::a('tmc/new', 'Новое устройство', $act);
        ?>
    </div>
    <div class="popUpMenu" id="popUpData">
        <?php
            HTML::a('tmc/issued_tmcs', 'Список выданных устройств', $act);
            HTML::a('tmc/free_tmcs', 'Список свободных устройств', $act);
            HTML::a('tmc/give', 'Выдать устройство', $act);
            HTML::a('tmc/take', 'Принять устройство', $act);
        ?>
    </div>
    <div class="popUpMenu" id="popUpObj">
        <?php
            HTML::a('tmc/storage', 'Места хранения устройств', $act);
            HTML::a('tmc/find_cell', 'Найти ячейку', $act);
            if ($cmdlevel == 10) {
                HTML::a('views/metrics', 'Метрика замеров', $act);
            }
        ?>
    </div>

    <div class="leftBar">
        <div data-menu="popUpMain">
            <img src="/images/svg/smopp.svg">
        </div>
        <div data-menu="popUpProject">
            <img src="/images/svg/projects.svg">
            <p>Компания</p>
        </div>
        <div data-menu="popUpTask">
            <img src="/images/svg/task.svg">
            <p>Задачи</p>
        </div>
        <div data-menu="popUpLocation">
            <img src="/images/svg/worker.svg">
            <p>Сотрудники</p>
        </div>
        <div data-menu="popUpWorker">
            <img src="/images/svg/obj.svg">
            <p>Объекты</p>
        </div>
        <div data-menu="popUpHandbook">
            <img src="/images/svg/handbook.svg">
            <p>Список устройств</p>
        </div>
        <div data-menu="popUpData">
            <img src="/images/svg/shipping.svg">
            <p>Передача устройств</p>
        </div>
        <div data-menu="popUpObj">
            <img src="/images/svg/warehouse.svg">
            <p>Места хранения</p>
        </div>
    </div>
