<?php /** @var string $login */ ?>
<!doctype html>
<html lang="ru">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Авторизация</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.1/css/bootstrap.min.css" integrity="sha384-VCmXjywReHh4PwowAiWNagnWcLhlEJLA5buUprzK8rxFgeH0kww/aWY76TfkUoSX" crossorigin="anonymous">
</head>
<body>
    <div class="wrapper">
        <form method="post" action="/">
            <h1 class="h3 mb-3 font-weight-normal text-center">Авторизация</h1>
            <label for="iLogin" class="sr-only"></label>
            <input type="text" name="login" class="form-control mb-3" placeholder="Логин" id="iLogin">
            <label for="iPass" class="sr-only"></label>
            <input type="password" name="pass" class="form-control mb-3" placeholder="Пароль" id="iPass">
            <button class="btn btn-primary btn-block mt-4" type="submit">Вход</button>
            <?php if ($login): ?>
                <div class="alert alert-danger mt-4" role="alert">Не верный логин или пароль</div>
            <?php endif; ?>
        </form>
    </div>
    <style type="text/css">
        form {
            width: 100%;
            max-width: 300px;
            padding: 15px;
            margin: auto;
        }
        .wrapper {
            margin-top: 10rem;
        }
        input {
            height: 38px;
            padding: 6px 10px;
            border: 1px solid #D1D1D1;
            border-radius: 4px;
            box-shadow: none;
            box-sizing: border-box;
        }
        button[type="submit"] {
            padding: 0 24px 2px 24px;
            font-size: 16px;
            font-weight: 500;
            line-height: 36px;
            border-radius: 38px;
        }
    </style>
</body>
</html>