<?php

namespace app\controllers;

use app\models\EmployeesModel;

/**
 * Делает запросы от SMoPP в ЕИПП
 */
class EmployeesController extends MainController
{
    /**
     * Получить список исполнителей по должности
     */
    public function actionGetworkers()
    {
        $employeesModel = new EmployeesModel();

        return $employeesModel->getWorkers([
            'placeOfRepair' => 'a84d0a15-08ec-11e5-829d-00155d6cab05'//из списка get_sld_list
        ]);
    } 

    /**
     * Получить статус сотрудника
     */
    public function actionGetemployeestatus()
    {
        $employeesModel = new EmployeesModel();

        return $employeesModel->getEmployeeStatus([
            'worker' => '25b3793b-ce67-11e6-aab3-00155d6cab04',
            'date' => '1562072228'
        ]);
    }
    
    /**
     * Получить график по исполнителю на дату
     */
    public function actionGetworkertimetable()
    {
        $employeesModel = new EmployeesModel();

        return $employeesModel->getWorkerTimetable([
            'name' => 'Ивлева Светлана Николаевна',
            'date' => $this->seconds()
        ]);
    }

    /**
     * Получить справочник должностей
     */
    public function actionGetpositionlist()
    {
        $employeesModel = new EmployeesModel();

        return $employeesModel->getPositionList();
    }
}
