<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "asusg_conditions_template".
 *
 * @property int $jobplan_id
 * @property int $finished_jobplan_id
 */
class AsusgConditionsTemplate extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_conditions_template';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['jobplan_id', 'finished_jobplan_id'], 'required'],
            [['jobplan_id', 'finished_jobplan_id'], 'integer'],
            [['jobplan_id', 'finished_jobplan_id'], 'unique', 'targetAttribute' => ['jobplan_id', 'finished_jobplan_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'jobplan_id' => 'Jobplan ID',
            'finished_jobplan_id' => 'Finished Jobplan ID',
        ];
    }
}
