<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "asusg_job_task".
 *
 * @property int $job_id
 * @property int $task_id
 */
class AsusgJobTask extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_job_task';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['job_id', 'task_id'], 'required'],
            [['job_id', 'task_id'], 'integer'],
            [['job_id', 'task_id'], 'unique', 'targetAttribute' => ['job_id', 'task_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'job_id' => 'Job ID',
            'task_id' => 'Task ID',
        ];
    }
}
