<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "asusg_jobplan".
 *
 * @property int $id
 * @property string $name
 * @property int $smopp_jt_id
 * @property int $asusg_id
 */
class AsusgJobplan extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_jobplan';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name'], 'required'],
            //[['smopp_jt_id', 'asusg_id'], 'integer'],
            [['name'], 'string', 'max' => 255],
            [['name'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            //'smopp_jt_id' => 'Smopp Jt ID',
            //'asusg_id' => 'Asusg ID',
        ];
    }
    
    public function getTaskstypes()
    {
        //return $this->hasMany(Tasktypes::className(), ['id' => 'smopp_jt_id']);
    }

    public function setSections()
    {
        //return $this->hasMany(Sections::className(), ['id' => 'smopp_jt_id']);
    }
}
