<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "asusg_employee".
 *
 * @property int $id
 * @property string $asu_id
 * @property string $name
 * @property int $smopp_id
 */
class AsusgMeasurements extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            //[['work_id'], 'unique'],
            [['measurement_id','measurement_stage','characteristic_id'], 'unique', 'targetAttribute' => ['measurement_id', 'measurement_stage','characteristic_id']]
            
        ];
    }
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_measurements';
    }
}
