<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "asusg_task".
 *
 * @property int $id
 * @property int $template_id
 * @property string $created
 */
class AsusgTask extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_task';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['template_id'], 'required'],
            [['template_id'], 'integer'],
            [['created'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'template_id' => 'Template ID',
            'created' => 'Created',
        ];
    }
}
