<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "beacons".
 *
 * @property int $id
 * @property int $location_id
 * @property double $x
 * @property double $y
 * @property double $z
 * @property string $uuid
 */
class Beacons extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'beacons';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['x', 'y','location_id','uuid'], 'required'],
            [['location_id'], 'integer'],
            [['x', 'y', 'z'], 'number'],
            [['uuid'], 'string', 'max' => 36],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'location_id' => 'Ид локации',
            'x' => 'точка X',
            'y' => 'Точка Y',
            'z' => 'Точка Z',
            'uuid' => 'Uuid',
        ];
    }
}
