<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "checkpoint_types_for_tasks".
 *
 * @property int $priority
 * @property int $tasktype_id
 * @property int $cp_type_id
 */
class CheckpointTypesForTasks extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'checkpoint_types_for_tasks';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['priority', 'tasktype_id', 'cp_type_id'], 'integer'],
            [['tasktype_id', 'cp_type_id'], 'required'],
            [['tasktype_id', 'cp_type_id'], 'unique', 'targetAttribute' => ['tasktype_id', 'cp_type_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'priority' => 'Priority',
            'tasktype_id' => 'Tasktype ID',
            'cp_type_id' => 'Cp Type ID',
        ];
    }
}
