<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "sections".
 *
 * @property int $id
 * @property string $name
 * @property string $locomotive_series
 * @property string $section_number
 * @property string $section_subnumber
 * @property string $dc_repair
 * @property string $type_repair
 * @property string $date_start_repair
 */
class Sections extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sections';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            //[['name', 'locomotive_series', 'section_number', 'section_subnumber', 'dc_repair', 'type_repair', 'date_start_repair'], 'required'],
            [['date_start_repair'], 'safe'],
            [['name', 'locomotive_series', 'section_number', 'section_subnumber', 'dc_repair', 'type_repair'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'locomotive_series' => 'Locomotive Series',
            'section_number' => 'Section Number',
            'section_subnumber' => 'Section Subnumber',
            'dc_repair' => 'Dc Repair',
            'type_repair' => 'Type Repair',
            'date_start_repair' => 'Date Start Repair',
        ];
    }
}
