<?php /** Created by Anton on 29.01.2020. */

namespace app\models\entity;

/**
 * This is the model class for table "tmc_status".
 *
 * @property int $id
 * @property string $title
 */
class TmcStatus extends \yii\db\ActiveRecord
{
    const TMC_STATUS_ISSUED = 1;
    const TMC_STATUS_IN_STORAGE = 2;
    const TMC_STATUS_REPAIR = 3;
    const TMC_STATUS_TRANSFERRED = 4;
    const TMC_STATUS_DECOMMISSION = 5;
    const TMC_STATUS_IN_CHARGE = 6;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tmc_status';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['title'], 'string', 'max' => 255],
        ];
    }
}