<?php
/** @var string $act */
/** @var string $pass */
$time_start = microtime(1);

require 'api/yiiInit.php';

require_once "doctrine/bootstrap.php";
require_once 'ocs.php';
require_once 'CheckPoint.php';
require_once 'CheckPointType.php';
header("Expires: 0");
header("Content-Type: text/html; charset=utf-8");
session_start();
error_reporting(0);

foreach (array_keys($_REQUEST) as $var) {
    ${$var} = $_REQUEST[$var];
}

require 'functions.php';
$link = \app\models\Doctrine::getLink();
//Глобальные переменные на всякий случай
list($db_hostname, $db_name, $db_username, $db_password) = \app\models\Doctrine::getDevConfig();

/** @var int $cmdlevel */
/** @var string $nameMain */
/** @var string $login */
require 'included/auth.php';
/** @var string $mycompany */
/** @var string $companyname */
include 'included/company.php';
?>
<!DOCTYPE html>
<html lang="ru">
<head>
    <!-- Basic Page Needs
    –––––––––––––––––––––––––––––––––––––––––––––––––– -->
    <meta charset="utf-8">
    <title>ProSys Management</title>
    <meta name="description" content="">
    <meta name="author" content="">

    <!-- Mobile Specific Metas
    –––––––––––––––––––––––––––––––––––––––––––––––––– -->
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- FONT
    –––––––––––––––––––––––––––––––––––––––––––––––––– -->
    <link rel="stylesheet" href="fonts/stylesheet.css">

    <!-- CSS
    –––––––––––––––––––––––––––––––––––––––––––––––––– -->
    <link rel="stylesheet" href="ProSysNew/content.css">
    <link rel="stylesheet" href="ProSysNew/datepicker.css">
    <link rel="stylesheet" href="ProSysNew/tabs.css">
    <link rel="stylesheet" href="ProSysNew/jquery-ui.min.css">
    <link rel="stylesheet" href="ProSysNew/datetimepicker.css">
    <link rel="stylesheet" href="ProSysNew/stylesheet.css">
    <!-- LTE -->
    <link rel="stylesheet" href="/lte/bower_components/bootstrap/dist/css/bootstrap.min.css">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="/lte/bower_components/font-awesome/css/font-awesome.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="/lte/bower_components/Ionicons/css/ionicons.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="/lte/dist/css/AdminLTE2.css">
    <!-- AdminLTE Skins. Choose a skin from the css/skins
       folder instead of downloading all of them to reduce the load. -->
    <link rel="stylesheet" href="/lte/dist/css/skins/_all-skins.min.css">
    <!-- Morris chart -->
    <link rel="stylesheet" href="/lte/bower_components/morris.js/morris.css">
    <!-- jvectormap -->
    <link rel="stylesheet" href="/lte/bower_components/jvectormap/jquery-jvectormap.css">
    <!-- Date Picker -->
    <link rel="stylesheet" href="/lte/bower_components/bootstrap-datepicker/dist/css/bootstrap-datepicker.min.css">
    <!-- Daterange picker -->
    <link rel="stylesheet" href="/lte/bower_components/bootstrap-daterangepicker/daterangepicker.css">
    <!-- bootstrap wysihtml5 - text editor -->
    <link rel="stylesheet" href="/lte/plugins/bootstrap-wysihtml5/bootstrap3-wysihtml5.min.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,600,700,300italic,400italic,600italic">
    <link rel="stylesheet" href="/lte/bower_components/select2/dist/css/select2.min.css">
    <!-- LTE -->
    <link rel="stylesheet" href="css/normalize.css">
    <link rel="stylesheet" href="css/skeleton.css">
    <link rel="stylesheet" href="css/layout.css">

    <script src="/lte/bower_components/jquery/dist/jquery.min.js"></script>
    <script src="ProSysNew/datepicker.js"></script>
    <script src="ProSysNew/tabs.js"></script>
    <script src="ProSysNew/jquery-ui.min.js"></script>
    <script src="ProSysNew/datetimepicker.js"></script>
    <script src="ProSysNew/script.js"></script>
    <script>var page = '';</script>
    <script src="ProSysNew/bootstrap.js" type="text/javascript"></script>
    <script src="layout/popUpMenu.js"></script>
    <!-- Favicon -->
    <link rel="icon" type="image/png" href="images/favicon.png">
    <script src="js/accordion.js"></script>
</head>
<body onload="accon(<?echo $accnum;?>)">
    <div class="wrapper">
        <div class="left">
            <?php require 'views/leftBar.php' ?>
        </div>
        <div class="top">
            <div class="loco-logo">
                <img src="/images/svg/lokoteh.svg">
            </div>
            <div class="top-nav">
                <div class="top_links">
                    <?
                    if ($cmdlevel==1 || $cmdlevel == 10) {
                        GetHrefActive('companies','Компании', false);
                        GetHrefActive('accounts','Аккаунты', false);
                    }
                    ?>
                </div>
                <div class="account">
                    <span class="account_name">
                        <strong><?= ($nameMain ?? $name) . ' [' . $login . ']</strong>mp_using<br><i>from</i> '
                            . $mycompany[1] . ' <i>editing</i> ' . $companyname ?>
                    </span>
                    <a href="?act=exit" class="logout"></a>
                </div>
                <ul class="nav navbar-nav" style="float: right;">
                    <li class="dropdown messages-menu" >
                        <a id="new_massage_dropdown" href="#" data-toggle="control-sidebar" data-toggle="control-sidebar">
                            <i class="fa fa-bell-o fa-2x" style="font-weight: normal; font-family: FontAwesome"></i>
                            <span id="new_massage_count" class="label label-default">0</span>
                        </a>
                    </li>
                </ul>
            </div>
        </div>
        <div class="content">
            <?php
            try {
                if ($incl != '') {
                    include($incl);
                }
            } catch (\Throwable $e) {
                echo $e->getMessage();
            }
            ?>
        </div>
    </div>

    <?php include 'views/chat.php' ?>

<!-- End Document
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->
    <script src="/checkpoints.js" type="text/javascript"></script>
    <script src="/locations.js" type="text/javascript"></script>
    <script src="/algo.js" type="text/javascript"></script>
    <script src="/staff.js" type="text/javascript"></script>
    <script src="/mail.js" type="text/javascript" encoding="utf-8"></script>
    <script src="/loco.js" type="text/javascript"></script>
    <script src="/operate.js" type="text/javascript"></script>

    <?php include 'views/lte-scripts.php' ?>

</body>
</html>


<?php
$time_end = microtime(1);
$time = $time_end - $time_start;
$time = round($time,5);
?>
<div class='generate' style='position:absolute;top:5px;right:30px'>Страница сгенерирована за <?= $time ?> сек.</div>