<?php
/**
 * @Entity @Table(name="diagnostic_maps")
 */
class DiagnosticMap extends BaseDBO implements ArrayExpressible
{
    /**
     * @ManyToOne(targetEntity="Section", inversedBy="diagnostic_maps")
     * @JoinColumn(name="section_id", referencedColumnName="id")
     */
    public $section;


    /**
     * @Id
     * @var string
     * @Column(type="string")
     */
    public $uuid;

    /**
     * @Column(type="datetime")
     */
    public $created;

    /**
     * @Column(type="integer")
     */
    public $section_id;

    public function toArray() {
        return get_object_vars($this);
    }
}