<?php

namespace classes;

class HTML
{
    /**
     * Выводит ссылку с действием (act)
     *
     * @param string $href
     * @param string $name текст ссылки
     * @param string $action текущее действие, если совпадает с $href, то добавляется класс active
     * @param bool $hr выводить ли разделитель?
     */
    public static function a(string $href, string $name = '', string $action = '', $hr = false)
    {
        echo '<a href="?act=' . $href . '"' . ($action == $href ? ' class="active"' : '') . '>' . $name . '</a>';
        if ($hr) echo '<hr>';
    }
}