<?php /** Created by Anton on 10.02.2020. */
/** По инвентарному номеру и ID компании возвращает характеристику (IP) камеры */

require '../yiiInit.php';

use app\models\entity\Tmc;
use app\models\entity\TmcType;

$in = Yii::$app->request->get('inventoryNum');
$company = (int) Yii::$app->request->get('company');

$camera = Tmc::findOne([
    'inventory_num' => $in,
    'company' => $company,
    'tmc_type' => TmcType::TMC_TYPE_CAMERA
]);

if (!$camera) {
    echo 'Камера не найдена';
} else {
    echo $camera->ip;
}
