<?php /** Created by Anton on 04.03.2020. */

use app\models\entity\Companies;
use app\models\entity\TmcStorage;

require '../yiiInit.php';

$title = (string)$_GET['id'];

list($companyId, $warehouse, $stack, $cell) = explode('.', $title);

$company = Companies::findOne($companyId);
$cell = TmcStorage::findOne(['title' => $title]);
$tmc = $cell->getTmc();

?>
<!doctype html>
<html lang="ru">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="../../ProSysNew/bootstrap.css">
    <title>Камера <?= $deviceId ?></title>
</head>
<body>
    <div class="container" style="max-width: 400px">
        <table class="table text-center">
            <thead>
                <tr>
                    <td colspan="2">
                        <h3>Ячейка <?= $cell->title ?></h3>
                    </td>
                </tr>
            </thead>
            <tr>
                <td>Компания</td>
                <td><?= $company->name ?></td>
            </tr>
        </table>
    <?php if ($tmc): ?>
        <table class="table text-center">
            <thead>
                <tr>
                    <td colspan="2">
                        <h3>Устройство <?= $tmc->title ?></h3>
                    </td>
                </tr>
            </thead>
            <tr>
                <td>Инвентарный номер</td>
                <td><?= $tmc->inventory_num ?></td>
            </tr>
            <tr>
                <td>Описание</td>
                <td><?= $tmc->desc ?></td>
            </tr>
        </table>
    <?php else: ?>
        <table class="table text-center">
            <thead>
                <tr>
                    <td colspan="2">
                        <h3>Ячейка пуста</h3>
                    </td>
                </tr>
            </thead>
        </table>
    <?php endif; ?>
    </div>
</body>
</html>