<?php

use app\models\entity\Storage;

$freeStorages = Storage::findAll(['tmc' => 0]);
?>
<div class="divContentScroll loco-scrol-blue">
    <div id="contentBox" class="contentBox">
        <p class="crumbs">Список устройств » Изменить данные устройства</p>
        <h2 class="contentHeader">Измените данные устройства</h2>
        <form action="/tmc/api/edit.php" method="post">
            <input type="hidden" name="_csrf" value="">
            <fieldset>
                Инвентарный номер:
                <br>
                <input name="inventoryNum" type="text" placeholder="Введете инвентарный номер">
                <br><br>
                Характеристика:
                <br>
                <input name="characteristic" type="text" placeholder="Введете данные для связи">
                <br><br>
                Место хранения:
                <select name="storage">
                    <?php foreach ($freeStorages as $storage): ?>
                        <option value="<?= $storage->id ?>"><?= $storage->title ?></option>
                    <?php endforeach; ?>
                </select>
                <br clear="all">
                <br>
                Примечание:<br>
                <textarea name="desc" placeholder="Описание"></textarea>
                <br>
            </fieldset>
            <button type="submit" class="">Изменить</button>
        </form>
    </div>
</div>