/** Created by Anton on 05.02.2020. */

$(document).ready(function () {
    $('body').off('change');
    var tabs = $('ul.nav.nav-tabs');
    var tabContent = $('.tab-content');
    var warehouses = tabs.first();
    var devices = tabContent.first();

    //Делаем активной первую вкладку со складами
    warehouses.find('li').first().addClass('active');
    $('.tab-content > div.tab-pane').first().addClass('fade in active');
    $('.form').first().addClass('fade in active');

    //Переключение вкладок со складами
    warehouses.find('li').on('click', function () {
        warehouses.find('li').removeClass('active');
        $(this).addClass('active');
        var tab = $(this).find('a').attr('href');
        devices.find('.tab-pane').removeClass('fade in active');
        $('#' + tab).addClass('fade in active');
    });

    //Переключение владок с формами
    var formTabs = tabs.last();
    var forms = tabContent.get(1);
    formTabs.find('li').on('click', function () {
        formTabs.find('li').removeClass('active');
        $(this).addClass('active');
        var tab = $(this).find('a').attr('href');
        $(forms).find('.tab-pane').removeClass('fade in active');
        $('#' + tab).addClass('fade in active');
    });

    //Подгрузка списка стеллажей
    var warehouseSelect = $('select[name="warehouse"]');
    var stackSelect = $('select[name="stack"]');
    var warehouse = warehouseSelect.val();
    getStacks(stackSelect, warehouse);

    warehouseSelect.on('change', function () {
        var warehouse = $(this).val();
        getStacks(stackSelect, warehouse);
    });

    function getStacks(stackSelect, warehouse) {
        $.ajax({
            method: 'GET',
            url: 'tmc/ajax/get_stacks.php',
            data: {
                warehouse: warehouse
            }
        }).done(function (data) {
            stackSelect.html(data);
        })
    }
});