<?php /** Created by Anton on 14.02.2020. */
/** @var string $includeForm */
/** @var $cameras */
/** @var $oilMeters */
/** @var $phones */
$devicesWitsTitle = [
    'Камера' => $cameras,
    'Масломер' => $oilMeters,
    'Телефон' => $phones
];
?>
<link href="/tmc/css/main.min.css" rel="stylesheet">
<style type="text/css">
    .contentBox {
        padding: 0 45px 54px;
    }
    .main_content {
        padding: 0;
        display: inline-flex;
    }
</style>

<div class="menuTask loco-scrol-blue scroller">
    <div class="menuTaskHeader">Список устройств</div>
    <div class="boxB4">
        <div class="inpBox">
            <input class="js-search" type="text" placeholder="Поиск">
            <img src="/images/find.svg" alt="">
        </div>
    </div>
    <div class="boxB5">
        <div class="accordion">
        <?php $i = 1?>
        <?php foreach ($devicesWitsTitle as $title => $oneTypeDevices): ?>
            <div class="trigger">
                <input type="checkbox" id="checkbox-<?= $i ?>" class="loco_checkbox"/>
                <label for="checkbox-<?= $i ?>" class="checkbox">
                    <?= $title ?>
                    <t class="loco_info" style="float:right; margin-right: 35px"><b><?= $oneTypeDevices['inCharge'] ?? 0 ?></b></t>
                    <t class="loco_info_red" style="float:right; margin-right: 10px"><b><?= $oneTypeDevices['issued'] ?? 0 ?></b></t>
                    <t class="loco_info" style="padding: 5px; float:right; margin-right: 10px"><b><?= $oneTypeDevices['total'] ?? 0 ?></b></t>
                    <i></i>
                </label>
                <div class="tmc-content loco-scrol-null scroller_null">
                    <?php foreach ($oneTypeDevices['list'] as $device): ?>
                        <a href="?act=tmc/detail/added&id=<?= $device['id'] ?>">
                            <div>
                                <h5><?= $device['title'] ?></h5>
                                <t class="<?= getColorByStatus($device['status']) ?>"><?= $statuses[$device['status']]['title'] ?></t>
                                <?php if ($device['name']): ?>
                                    <t class="loco_grey" style="float:right"><?= $device['name'] ?></t>
                                <?php endif; ?>
                                <?php if ($device['status'] == 6): ?>
                                    <t class="loco_grey" style="float:right"><?= $device['storage'] ?></t>
                                <?php endif; ?>
                            </div>
                        </a>
                    <?php endforeach; ?>
                </div>
            </div>
            <?php $i++ ?>
        <?php endforeach; ?>
        </div>
    </div>
</div>
<?php if ($includeForm) {
    require (dirname(__DIR__) . '/tmc/forms/' . $includeForm . '.php');
}?>
<div role="log" aria-live="assertive" aria-relevant="additions" class="ui-helper-hidden-accessible"></div>
<script type="application/javascript" src="tmc/js/search.js"></script>